import sys
import random
import datetime
from datetime import timedelta

from ardi.driver import histdriverbase

def fixdate(dt):
	ps = dt.find('.')
	if ps > -1:
		return dt[0:ps]
	return dt

class ardisimdriver:
    def __init__(self):
        self.path = ""
	
    def SetAddress(self, addr):
        self.path = addr
		
    def Connect(self):
		try:		
			self.con = sql.connect(self.path)
			return True
		except:
			return False		
		
    def Disconnect(self):
		self.con.close()
		pass
        
    def Query(self, points, start,end,function,grain,first):
		self.core.logger.info("Performing '" + function + "' query between " + start + " and " + end + " with " + str(grain) + " grain.") 								

		sd = datetime.datetime.strptime( start, "%Y-%m-%d %H:%M:%S" )
		ed = datetime.datetime.strptime( end, "%Y-%m-%d %H:%M:%S" )

		if sd == ed:
			out = ""
			n = 0
			#print "Oututting Points For " + str(sd)
			for p in points:
				val = round(random.random() * 100.0,2)
				out = out + self.core.AddRecord(n,sd,val,p)
				n= n + 1
			#sd = sd + step
			return out.encode('ascii')

		diff = ed - sd

		secs = diff.seconds + (diff.days * (60*60*24))

		count = 50
		if grain > 0:
			count = secs / int(grain)
		else:
			count = int(grain)
			if count <= 1:	
				count = 2;
		stepsize = secs / count
		step = timedelta(seconds=stepsize)

		#out = "Name, Timestamp, Value\r\n"
		out = ""
		#print "Trying..."
		for x in range(0,count):
			n = 0
			#print "Oututting Points For " + str(sd)
			for p in points:
				val = round(random.random() * 100.0,2)
				out = out + self.core.AddRecord(n,sd,val,p)
				n= n + 1
			sd = sd + step
					
		#print "Done!"
		#print out.encode('ascii')
		return out.encode('ascii')
		            
class driverfactory:
    def createinstance(self):
        return ardisimdriver()
            
if __name__ == "__main__":
    sdf = driverfactory()
    base = histdriverbase.historian()
    base.start(sdf)